local mod = HudMap:NewModule("Tracking", "AceEvent-3.0")
local trackingSpells = {[2383] = true, [2580] = true, [43308] = true}
local playerGUID = UnitGUID("player")

function mod:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("PLAYER_UPDATE_RESTING", "UpdateGatherMode")
	self:RegisterEvent("UPDATE_STEALTH", "UpdateGatherMode")
	self:RegisterEvent("ZONE_CHANGED", "UpdateGatherMode")
	self:UpdateGatherMode()	
end

function mod:UpdateGatherMode()
	local flag
	
	if IsInInstance() or IsResting() or IsStealthed() or GetNumRaidMembers() > 0 then
		flag = false
	else
		for k, v in pairs(trackingSpells) do
			local name, _, tex = GetSpellInfo(k)
			if tex == GetTrackingTexture() then
				flag = true
				break
			end
		end
	end
	if flag ~= nil then self:ToggleGatherMode(flag) end
end

function mod:ToggleGatherMode(flag)	
	if flag == true and not self.trackingMarker then
		HudMapMinimap:SetZoom(0)
		self.trackingMarker = HudMap:PlaceRangeMarkerOnPartyMember([[SPELLS\CIRCLE.BLP]], "player", 100, nil, 0, 0.7, 0, 0.6, "ADD"):Appear()
	elseif flag == false and self.trackingMarker then
		self.trackingMarker:Free()
		self.trackingMarker = nil
	end
end

function mod:COMBAT_LOG_EVENT_UNFILTERED(ev, timestamp, event, srcGUID, srcName, srcFlags, destGUID, destName, destFlags, spellID, ...)
	if srcGUID == playerGUID and trackingSpells[spellID] then
		if event ==  "SPELL_AURA_REMOVED" then
			self:ToggleGatherMode(false)
		elseif event == "SPELL_AURA_APPLIED" then
			self:ToggleGatherMode(true)
		end			
	end
end